﻿/**
配列。

たいそうな名前だけどしょうもないことをやってるだけ。
可能な限りpublic importされるstd.arrayで済ませたい。

History:
	1.000:
		新規作成。
*/
module nemuxi.negui.system.small.array;

debug import std.stdio: wl = writefln, pl = printf;
debug(array) void main() {}

import algorithm=std.algorithm;
public import std.array;
import std.contracts;


public import nemuxi.negui.system.text;
public import nemuxi.negui.system.exception;
public import nemuxi.negui.system.literal;

///
class NeGuiArrayException: NeGuiException {
	mixin MixInNeGuiException;
}

/**
要素が使用可能か。

History:
	1.021:
		[S] 名前変更(safeIndex -> isSafe)。
*/
bool isSafe(T)(in T[] Array, size_t Index) {
	return Array.length && Array.length > Index;
}
/// ditto
bool isSafe(T)(in T[] Array, size_t From, size_t Size) {
	return Array.safeIndex(From) && Array.safeIndex(From + Size);
}
alias isSafe safeIndex;
debug(array) unittest {
	int[5] a;
	assert(safeIndex(a, 4));
	assert(!safeIndex(a, 5));
	assert(!safeIndex(a, 10));
	assert(safeIndex(a, 0, 2));
	assert(safeIndex(a, 0, 4));
	assert(!safeIndex(a, 0, 5));
	assert(safeIndex(a, 2, 2));
	assert(!safeIndex(a, 5, 0));
	assert(safeIndex(a, 0, 0));

	assert(a.safeIndex(1));
	assert(!a.safeIndex(10));
	assert(a.safeIndex(0, 1));
	assert(!a.safeIndex(0, 10));
}

/**
削除。

むかしPhobosにあったような気がしたんだけどなぁ。
*/
T[] erase(T)(ref T[] Array, size_t Index) {
	enforce(Array.safeIndex(Index), new NeGuiArrayException(Text("Array.length == %s <= Index == %s", Array.length, Index)));

	if(Array.length == 1) {
		assert(Index == 0);
		Array.length = 0;
	} else if(Array.length-1 == Index) {
		Array.length = Array.length - 1;
	} else {
		if(Index) {
			Array = Array[0 .. Index] ~ Array[Index+1 .. Array.length];
		} else {
			Array = Array[1 .. Array.length];
		}
	}

	return Array;
}
debug(array) unittest {
	int[] fa1() { return [1,2,4,8,16];}
	int[][] fa2() { return [
		[2,4,8,16],
		[1,4,8,16],
		[1,2,8,16],
		[1,2,4,16]
	];}
	int[] a;
	
	a=fa1;
	assert(a.length == 5);
	a.erase(4);
	assert(a.length == 4);
	assert(a[$-1] == 8);
	a=fa1;
	a.erase(0);
	assert(a[0] == 2);

	
	foreach(index; 0 .. fa1.length-1) {
		a=fa1;
		assert(a.erase(index)==fa2[index]);
	}
}

T[] autoIncrement(T)(ref T[] Array, in size_t Index, in size_t Increment=BUFFER.INCREMENT)
out(r) {
	assert(r.safeIndex(Index));
}
body {
	if(Array.length <= Index) {
		Array.length = Array.length + Increment;
	}
	
	return Array;
}

