﻿/**
内部情報統括。
*/
module nemuxi.system.application;

debug import std.stdio: wl = writefln, pl = printf;

debug(application) void main() {}

import std.stream;
import std.string;
import std.math;
import std.contracts;

import win32.windows;

/+
import nemuxi.base;
import nemuxi.negui.file.file;
import nemuxi.file.data;
import nemuxi.file.app;
import nemuxi.file.exec;
import nemuxi.file.items.group;
import nemuxi.file.items.itemif;
//import nemuxi.file.items.timer;
import nemuxi.file.items.item;
import nemuxi.file.items.structure;
import nemuxi.file.items.itemfunc;
import nemuxi.file.items.linkitem;
import nemuxi.negui.draw.canvas;
import nemuxi.image.icon;
//import nemuxi.image.font;
import nemuxi.negui.draw.unit;
import nemuxi.negui.window.window;
import nemuxi.negui.window.adtb;
import nemuxi.negui.environ.variable;
;
+/
import etc.kareki.kareki;

import nemuxi.file.items.group;
import nemuxi.file.items.item;
import nemuxi.file.items.linkitem;
import nemuxi.file.items.itemfunc;
import nemuxi.file.items.itemif;
import nemuxi.file.app;
import nemuxi.negui.system.base;
import nemuxi.file.items.structure;
import nemuxi.negui.file.file;
import nemuxi.file.data;
import nemuxi.base;
import nemuxi.negui.system.type.enumerated;
import nemuxi.negui.environ.variable;
;
import nemuxi.file.exec;


/**
ビバ！グローバル変数。

History:
	1.00β12:
		使用禁止。
*/
deprecated public Application gApp;
/**
アクセスしたくはないけれどもドキュメントには残したい、
そんな淡い思いをのせてprotectedな保護。

おかしいよね、finalなのに。
*/
final class Application {
	protected {
		AkiDocument AppDataBase;   // プログラムデータ秋文書
		AkiDocument GroupDataBase; // グループデータ秋文書
		AkiDocument ItemsDataBase; // アイテムデータ秋文書
	}
	Kareha groupBase() {
		assert(GroupDataBase);
		return GroupDataBase["Group"];
	}
	Kareha itemBase() {
		assert(ItemsDataBase);
		return ItemsDataBase["Item"];
	}
	
	App AppData; /// プログラムデータ

	Main MainData; /// メイングループデータ
	Sub MenuData; /// メニューグループデータ

	protected {
		string MainGroupName; /// 現在メイングループ
		string SubGroupName; /// 現在サブグループ
		string MenuGroupName; /// 現在メニューグループ
		Item FolderItem;
	}
	
	this() {}

	/**
	History:
		1.00β19:
			[S] privateからstatic。
	*/
	static AkiDocument DataFileRead(in Text FillAddress) {
		
		if(FILE.isExistence(FillAddress)) {
			try {
				// 読み込み
				return ReadAkiDocument(FillAddress);
			} catch(Exception e) {
				return new AkiDocument();
			}
		} else {
			return new AkiDocument();
		}
	}
	/***/
	void readApp(in Text AppFile) {
		delete AppDataBase;
		AppDataBase = DataFileRead(AppFile);
		
		AppData=new App(AppDataBase);

		LanguageData.loadDocument(DataFileRead(StaticData.languageFolder ~ AppData.language));
	}
	/**
	History:
		1.00β18:
			[S] Main.menuGroupNameを使用。
	*/
	void readGroups(in Text GroupFile) {
		delete GroupDataBase;
		GroupDataBase = DataFileRead(GroupFile);
		invariant Trees = ["Group", "Group/" ~ Main.menuGroupName.toString];
		foreach(Tree; Trees) {
			if(!(Tree in GroupDataBase)) {
				GroupDataBase[Tree] = 0;
				GroupDataBase[Tree].fileKill();
			}
		}
		MainData = new Main(GroupDataBase[Trees[0]]);
		MenuData = new Sub(MainData, GroupDataBase[Trees[1]]);
		if(MainData.length) {
			// 何がしたかったのか忘れた
		} else {
			MainGroupName = SubGroupName = MenuGroupName = null;
		}
	
	}
	/***/
	void readItems(in Text ItemsFile) {
		delete ItemsDataBase;
		ItemsDataBase = DataFileRead(ItemsFile);

		if(!("Item" in ItemsDataBase)) {
			ItemsDataBase["Item"] = 0;
			ItemsDataBase["Item"].fileKill();
		}
	}
	private void DataFileWrite(Text FillAddress, AkiDocument DataBase)
	in {
		assert(DataBase);
	}
	body {
		WriteAkiDocument(FillAddress, DataBase);
	}
	void writeApp(Text AppFile) {
		DataFileWrite(AppFile, AppDataBase);
	}
	void writeGroup(Text GroupFile) {
		DataFileWrite(GroupFile, GroupDataBase);
	}
	void writeItems(Text AppFile) {
		DataFileWrite(AppFile, ItemsDataBase);
	}
	
	/**
	ボタン型の初期グループ名。

	Return:
		メイン・サブのどちらかが不完全の場合はnullを返す。
		両方が有効であればその文字列配列を返す。
		[0]:メイン
		[1]:サブ
	*/
	Text[] initExeButtonGroup() {
		if(!MainData.baseLength) {
			return null;
		}
		
		auto MainGroupName=MainData.baseName(0);

		assert(MainGroupName.length);

		try {
			auto SubData=MainData.subGroup(MainGroupName);
			auto SubGroupName=SubData.baseName(0);
		
			if(!SubGroupName.length) {
				return null;
			}

			return [MainGroupName, SubGroupName];
		} catch(Throwable e) {
			Logger.write(e);
			return null;
		}
	}
	Text initExeMenuGroup() {
		auto MenuGroupName=MenuData.baseName(0);
		
		return MenuGroupName;
	}
	/**
	メイングループ名取得。
	*/
	Text getMainGroupName() {
		return MainGroupName.toText;
	}
	/**
	サブグループ名取得。
	*/
	Text getSubGroupName() {
		return SubGroupName.toText;
	}
	/**
	メニューグループ名取得。
	*/
	Text getMenuGroupName() {
		return MenuGroupName.toText;
	}

	
	/**
	メイングループ変更。

	Paraqms:
		MainGroupName = メイングループ名。

	Return:
		変更出来た場合はtrue、出来なかった場合はfalse。
	*/
	//bool changeMainGroup(string MainGroupName) {//}
	bool changeMainGroup(Text MainGroupName) {
		if(MainData.inBaseName(MainGroupName)) {
			this.MainGroupName = MainGroupName.toString;
			return true;
		}
		
		return false;
	}
	/**
	サブグループ変更。

	Paraqms:
		SubGroupName = サブグループ名。

	Return:
		変更出来た場合はtrue、出来なかった場合はfalse。
	*/
	bool changeSubGroup(Text SubGroupName) {
		if(!MainData.inBaseName(MainGroupName.toText)) {
			return false;
		}
		
		auto SubNames=MainData.childNames(MainGroupName.toText);
		
		foreach(SubName; SubNames) {
			if(SubName == SubGroupName) {
				this.SubGroupName = SubGroupName.toString;
				return true;
			}
		}
		
		return false;
	}
	/**
	メニューグループ変更。

	Paraqms:
		MenuGroupName = メニューグループ名。

	Return:
		変更出来た場合はtrue、出来なかった場合はfalse。
	*/
	bool changeMenuGroup(Text MenuGroupName) {
		auto SubNames=MenuData.baseNames();
		
		foreach(SubName; SubNames) {
			if(SubName == MenuGroupName) {
				this.MenuGroupName = MenuGroupName.toString;
				return true;
			}
		}
		
		return false;
	}

	/**
	グループから連続アイテムの取得。

	Params:
		MainGroupName = メイングループ。
		                nullならメニュー。

		SubGroupName = サブグループ。
	*/
	private BM_ITEM[] GetItems(Text MainGroupName, Text SubGroupName) {
		bool ExeButton = MainGroupName.length ? true: false;
		
		if(ExeButton) {
			auto sub=MainData.subGroup(MainGroupName);
			return ButtonMenuGroupItems(sub.childNames(SubGroupName), this.itemBase, true, AppData.exeButtonIcon());
		} else {
			return ButtonMenuGroupItems(MenuData.childNames(SubGroupName), this.itemBase, true, AppData.exeMenuIcon());
		}
	}
	///
	BM_ITEM[] getExeButtonItems(Text MainGroupName, Text SubGroupName) {
		return GetItems(MainGroupName, SubGroupName);
	}
	///
	BM_ITEM[] getExeMenuItems(Text MenuGroupName) {
		return GetItems(Text.emptyText, MenuGroupName);
	}

	/**
	グループ番号からグループ名取得。
	*/
	void getButtonGroupName(ushort MainGroupIndex, ushort SubGroupIndex, out Text MainGroupName, out Text SubGroupName) {
		bool MainChange=true;
		if(!MainGroupIndex) {
			MainGroupName = this.MainGroupName;
			MainChange = false;
		} else {
			MainGroupIndex--;
		}
		SubGroupIndex--;

		if(MainChange) {
			MainGroupName = MainData.baseName(MainGroupIndex);
		}
		auto SubGroup=MainData.subGroup(MainGroupName);
		SubGroupName = SubGroup.baseName(SubGroupIndex);
	}

	/**
	指定アイテムの実行。

	Params:
		Item = 実行するアイテム。

		PlusInfo = 実行するアイテムに上書きする情報。
		           未指定の場合はnull。上書きされるものは、
		           <ul>
		             <li>作業フォルダ</li>
		             <li>オプション</li>
		             <li>表示方法</li>
		           </ul>

	Exception:
		とりあえず失敗ならExceptionを投げる。

	History:
		1.00β14:
			[P] 環境変数を考慮。
	*/
	void executeItem(Item item, OverrideInfo* OverInfo=null) {
		void ExecuteItem(Item item, OverrideInfo* OverInfo) {
			bool ExecFlag=false;
			Text Address;
			with(Item.TYPE) switch(item.type()) {
				case NORMAL:
					Address  = item.address;
					ExecFlag = true;
					break;
				case URI:
					Address  = item.uri;
					ExecFlag = true;
					break;
				case MULTI:
					foreach(IDs; item.multi) {
						ExecuteItem(new Item(IDs, this.itemBase()), OverInfo);
					}
					break;
				case LINK:
					ExecuteItem(new LinkItem(item, this.itemBase()), OverInfo);
					break;
				default:
					assert(false);
			}
			version(unittest) {
				if(!ExecFlag) assert(!Address.length);
			}
			struct OverrideFlag {
				bool WorkFolder;
				bool Option;
				bool Show;
			}
			OverrideFlag of;
			// 実行
			if(ExecFlag) {
				Text WorkFolder = GetWorkFolder(item, this.itemBase());
				Text Option     = item.option;
				SHOW Show       = item.show;
				
				if(OverInfo) {
					// 作業フォルダ情報上書き
					if((OverInfo.Mask & OverrideInfo.MASK.WORK) == OverrideInfo.MASK.WORK) {
						WorkFolder = OverInfo.WorkFolder;
						of.WorkFolder = true;
					}
					// コマンドラインオプション情報上書き
					if((OverInfo.Mask & OverrideInfo.MASK.OPTION) == OverrideInfo.MASK.OPTION) {
						Option = OverInfo.Option;
						of.Option = true;
					}
					// 表示情報上書き
					if((OverInfo.Mask & OverrideInfo.MASK.SHOW) == OverrideInfo.MASK.SHOW) {
						Show = OverInfo.Show;
						of.Show = true;
					}
				}

				// 環境変数変換
				Address=toPlain(Address);
				WorkFolder=toPlain(WorkFolder);
				
				if(FILE.isExistence(Address)) {
					if(FILE.isFile(Address)) {
						FileExecute(
							Address,
							Option,
							WorkFolder,
							Show,
							AppData.folder == FOLDER.EXPLORER,
							null
						);
					} else {
						enforce(FILE.isFolder(Address), new NemuxiException("どないせーと"));
						if(AppData.folder == FOLDER.PROGRAM) {
							assert(FolderItem);
							OverrideInfo ofTemp;
							ofTemp.Mask       = OverrideInfo.MASK.WORK | OverrideInfo.MASK.OPTION | OverrideInfo.MASK.SHOW;
							ofTemp.WorkFolder = WorkFolder.toString;
							ofTemp.Option     = Address.quot('"').toString;
							ofTemp.Show       = Show;
							ExecuteItem(FolderItem, &ofTemp);
						} else {
							FolderExecute(Address, AppData.folder, Show, null);
						}
					}
				} else {
					FileExecute(
						Address,
						Option,
						WorkFolder,
						Show,
						AppData.folder == FOLDER.EXPLORER,
						null
					);
				}
			}
			
		}
		try {
			ExecuteItem(item, OverInfo);

			// 実行情報設定。
			// 日時とか使用回数とかその辺の情報
			// OverrideInfo情報は設定しない。
			item.historyLast = new ItemDateTime();
			item.historyUse  = item.historyUse + 1;
			
		} catch(Exception e) {
			throw new NemuxiException(
				format(
					"アイテム(%s)実行例外",
					item.itemID
				),
				EC.NONE,
				e
			);
		}
	}
	
	/**
	パスの実行。

	History:
		[P]:
			[P] catchする例外の範囲を変更。
		
		1.00β11:
			引数をinに。
	*/
	void executePath(in Text path) {
		try {
			if(FILE.isFile(path)) {
				FileExecute(path, Text.emptyText, Text.emptyText, SHOW.SHOWNORMAL, AppData.folder == FOLDER.EXPLORER);
			} else {
				if(AppData.folder == FOLDER.PROGRAM) {
					assert(FolderItem);
					OverrideInfo OverInfo;
					OverInfo.Mask   = OverrideInfo.MASK.OPTION | OverrideInfo.MASK.SHOW;
					OverInfo.Option = path.quot('"').toString();
					OverInfo.Show   = SHOW.SHOWNORMAL;
					this.executeItem(FolderItem, &OverInfo);
				} else {
					FolderExecute(path, AppData.folder, SHOW.SHOWNORMAL, null);
				}
			}
		} catch(Exception e) {
			Logger.write(e);
			FileExecute(path, Text.emptyText, Text.emptyText, SHOW.SHOWNORMAL, AppData.folder == FOLDER.EXPLORER);
		}
	}
	/+
	debug(this) unittest {
		auto a=MakeApplication();
		a.executeItem(new Item(`z`,a.itemBase), OverInfo);
	}
	+/
	debug(application) unittest {
		auto a=MakeApplication();
		//a.executePath(Text(`explorer /root,,::{645FF040-5081-101B-9F08-00AA002F954E}`));
	}

	bool isAppDeskTopToolBar(App.POSITION Position) {
		with(App.POSITION) return !(Position == FLOAT || Position == SMALL);
	}
}

/**
Applicationの生成と保存。。

Exception:
	ぐっだぐだになったらNemuxiExceptionを投げる。
*/
Application MakeApplication() {
	auto app=new Application();
	Text DataFolder=StaticData.dataFolder();

	Text AppFile   = PATH.addFolderSep(StaticData.dataFolder) ~ StaticData.applicationDataFile;
	Text ItemsFile = PATH.addFolderSep(StaticData.dataFolder) ~ StaticData.itemDataFile;
	Text GroupFile = PATH.addFolderSep(StaticData.dataFolder) ~ StaticData.groupDataFile;

	app.readApp(AppFile);
	app.readGroups(GroupFile);
	app.readItems(ItemsFile);
	
	if(app.AppData.folder == FOLDER.PROGRAM) {
		try {
			app.FolderItem = new Item(app.AppData.folderProgram, app.itemBase);
		} catch(Throwable e) {
			Logger.write(e);
			app.AppData.folder = FOLDER.NORMAL;
		}
	}


	return app;
}
debug(application) unittest {
	auto a=MakeApplication;
	/+
	a.AppData.exeButtonText=true;
	a.AppData.exeButtonIcon=Icon.TYPE.NORMAL;
	wl(a.SubGroup);
	SIZE n;
	a.getExeButtonSize(n);
	wl("w=%s", n.cx);
	wl("h=%s", n.cy);
	auto groups=a.initExeButtonGroup;
	wl(groups);
	foreach(ppp; a.GetItems(groups[0], groups[1])) with(ppp){
		wl("name=", name);
		wl("icon=", icon);
		wl("live=", live);
	}
	+/
	/+
	wl(a.changeMainGroup("いろいろ"));
	wl(a.changeSubGroup("ブラウザ・ビューア"));
	wl(a.changeMenuGroup("bb"));
	string b,c;
	a.getButtonGroupName(2, 1, b, c);
	wl(b);
	wl(c);
	+/
	//a.executeItem(new Item("firefox", a.itemBase));
	//a.executeItem(new Item("iii", a.itemBase));
}
/// ditto
void SaveApplication(Application app) {
	Text DataFolder=StaticData.dataFolder();
	
	FILE.makeFolder(DataFolder);

	Text AppFile   = PATH.addFolderSep(StaticData.dataFolder) ~ StaticData.applicationDataFile;
	Text ItemsFile = PATH.addFolderSep(StaticData.dataFolder) ~ StaticData.itemDataFile;
	Text GroupFile = PATH.addFolderSep(StaticData.dataFolder) ~ StaticData.groupDataFile;
	
	app.writeApp(AppFile);
	app.writeItems(ItemsFile);
	app.writeGroup(GroupFile);
}


